(define-module (alterator exit-handler)
  :export (with-exit-handler
           at-exit))


(define *handlers* '())

(define (at-exit proc) (set! *handlers* (cons proc *handlers*)))

(define (run-at-exit)
  (for-each (lambda(x) (x)) *handlers*))

(define (with-exit-handler proc)
  (catch
   #t
   (lambda ()
     (lazy-catch
      #t
      proc
      (lambda (key . args)
        (or (eq? key 'quit)
            (begin (format #t "backtrace:~%")
	           (display-backtrace (make-stack #t) (current-error-port))))
        (apply throw key args))))
   (lambda args
     (run-at-exit)
     (apply throw args)))
  (run-at-exit))
