(define-module (alterator transport cmdline-channel)
  :use-module (srfi srfi-1)
  :use-module (alterator plist)
  :use-module (alterator woo)
  :use-module (alterator algo)
  :export(cmdline-in))

(define (cmdline->cmd cmdline)
  (and (pair? cmdline)
       (plist? (cdr cmdline))
       (cons (car cmdline)
             (reverse (plist-fold (lambda(x y res) (cons* y (string->symbol x) res))
                                 '()
                                 (cdr cmdline))))))
(define (print-command key cmd)
  (if key
    (let ((result (cond-plistq  (sure-symbol key) (cdr cmd) 'not-found)))
      (or (eq? result 'not-found) (format #t "~A~%" result)))
    (begin
      (newline)
      (plist-for-each
	(lambda (x y) (format #t "~A:~A~%" x y))
	(cdr cmd)))))

(define (cmdline-in key cmdline)
  (lambda (cmds next)
    (let ((cmd (cmdline->cmd cmdline)))
      (and cmd
           (woo-catch
            (thunk
	      (for-each (lambda(cmd) (print-command key cmd))
			(woo-try-cmds (next (list cmd)))))
            (lambda(reason)
              (format (current-error-port) "fatal error:~A~%" reason)
              (exit 1)))))))
